﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace FibonacciSequence
{
    public class Program
    {
        public static void Main(string[] args)
        {
            ulong n = ulong.Parse(Console.ReadLine());

            ulong dynamic = DynamicFibonacci(n);
            Console.WriteLine(dynamic);

            ulong recursive = RecursiveFibonacci(n);
            Console.WriteLine(recursive);

            Console.ReadLine();
        }

        public static ulong RecursiveFibonacci(ulong n)
        {
            if (n <= 2)
            {
                return 1;
            }
            
            return RecursiveFibonacci(n - 1) + RecursiveFibonacci(n - 2);
        }

        public static Dictionary<ulong,ulong> FibonacciCache = new Dictionary<ulong, ulong>();
        public static ulong DynamicFibonacci(ulong n)
        {
            if (FibonacciCache.ContainsKey(n))
            {
                return FibonacciCache[n];
            }

            if (n <= 2)
            {
                return 1;
            }

            ulong result = DynamicFibonacci(n - 1) + DynamicFibonacci(n - 2);
            FibonacciCache.Add(n, result);
            return result;
        }


    }
}